# This script demonstartes using the SUB-20 MDIO interface.
# Developed by mmintz Mon Jan 10, 2011. Thanks for sharing this script !
# Last tested under Python 3.2.3 on Windows

from ctypes import *

#need to raise exception if dev_id is 0
def get_device_info ():
 """
 Returnes a string which has the aaa product name and serial number
 of the mdio interface device
 """
 helper = cdll.LoadLibrary("C:/Windows/System32/sub20")
 dev_id = helper.sub_open (0)
 errno = c_int.in_dll (helper, "sub_errno")
 print ("device id is: {0} sub_errno is: {1}".format (dev_id, errno.value))

 sub_get_product_id = helper.sub_get_product_id
 sub_get_product_id.argtypes = [c_int, c_char_p, c_int]
 s = create_string_buffer( 60)

 sub_get_product_id (dev_id, s, 60)
 print ("Product ID:", s.value.decode("utf-8"))


 sub_get_serial_number = helper.sub_get_serial_number
 sub_get_serial_number.argtypes = [c_int, c_char_p, c_int]
 s2 = create_string_buffer( 67)

 sub_get_serial_number (dev_id, s2, 67)
 print ("Serial Number:", s2.value.decode("utf-8"))

 helper.sub_close (dev_id)

 return "Device: " + s.value.decode("utf-8") + " " + s2.value.decode("utf-8")

def transaction (op_code, phy_adrdess, device_address, data):
 """
 Execute a mdio cluase 45 transaction.
 Returnes an integer on read or read post increment.
 op_code
 0 is for Address
 1 is for Write
 2 is for Read
 3 is for Read post increment
 """
 helper = cdll.LoadLibrary("C:\\Windows/System32/sub20")
 dev_id = helper.sub_open (0)
 errno = c_int.in_dll (helper, "sub_errno")
 print ("device id is: {0} sub_errno is: {1}".format (dev_id, errno.value))

 sub_mdio45 = helper.sub_mdio45
 sub_mdio45.argtypes = [c_int, c_int, c_int, c_int, c_int, POINTER (c_int)]

 i = c_int(1)
 returned = pointer(i)
 foo = sub_mdio45 (dev_id, op_code, phy_adrdess, device_address, data, returned)
 errno = c_int.in_dll (helper, "sub_errno")
 print ("returned is: {0} sub_errno is: {1}".format (foo, errno.value))

 helper.sub_close (dev_id)

 return returned[0]

get_device_info ()
transaction(1, 2, 3, 4)









